DEFINT A-Z

declare sub ClearScreen ()
declare sub ClearViewPort ()
declare sub CloseGraph ()
declare sub Dissolve ()
declare sub Ellipse (byval X  as word, byval Y  as word, _
                     byval XR as word, byval YR as word)
declare sub EndMouse ()
declare sub FillArea (byval X as word, byval Y as word, _
              byval Colour as word)
declare sub FillCircle (byval X as word, byval Y as word, _
                        byval R as word)
declare sub FillEllipse (byval X as word,  byval Y as word, _
                         byval XR as word, byval YR as word)
declare sub FillRectAngle (byval X1 as word, byval Y1 as word, _
                           byval X2 as word, byval Y2 as word)

' Before calling GetImage een array Image has to be dimensioned
' with a size equal to (X2 - X1 + 1) * (Y2 - Y1 + 1) + 4 bytes.
' GetImage needs a far pointer to that array.

declare sub GetImage (byval X1 as word, byval Y1 as word, _
                      byval X2 as word, byval Y2 as word, _
                      byval Image AS DWORD)

' GetMouse returns the button status
'       bit     meaning (if set)
'        0      left button pushed
'        1      right button pushed
'        2      middle button pushed

declare function GetMouse% (X as integer, Y as integer)

' GetMousePress returns the number of button presses
'       Button has the following meaning:
'       0 = left button
'       1 = right button
'       2 = middle button

declare function GetMousePress% (byval Button as integer, _
              X as integer, Y as integer)

' GetMouseRelease returns the number of button releases
'       Buttonn has the following meaning:
'       0 = left button
'       1 = right button
'       2 = middle button

declare function GetMouseRelease% (byval Button as integer, _
              X as integer, Y as integer)

' GetPalette& returns the palette numbered ColorNumber as
' 65536 * Red + 256 * Green + Blue

declare function GetPalette& (byval ColorNumber as word)

' GetPixel returns the color of the pixel at the given coordinates

declare function GetPixel (byval X as word, byval Y as word)

declare sub HideMouse ()

' InitGraph returns 0 if the 640x400x256 mode couldn't be initialized
' (for instance with a non-VESA compatible video card) and -1
' otherwise

declare function InitGraph% ()

' InitMouse returns 0 if the mouse driver couldn't be initialized
' and -1 otherwise

declare function InitMouse% ()

declare sub LimitMouse (byval MinX as integer, byval MinY as integer, _
                        byval MaxX as integer, byval MaxY as integer)

declare sub OutStr (byval X as word, byval Y as word, byval Text as string)

' PutImage needs a far pointer to an array Image made by GetImage,
' containing the image to put on the screen

declare sub PutImage (byval X as word, byval Y as word, _
                      byval Image AS DWORD)
declare sub PutCircle (byval X as word, byval Y as word, _
                       byval R as word)
declare sub PutLine (byval X1 as word, byval Y1 as word, _
                     byval X2 as word, byval Y2 as word)
declare sub RectAngle (byval X1 as word, byval Y1 as word, _
                       byval X2 as word, byval Y2 as word)

' SetAllPalette needs an long array Palet with 256 elements containing
' the palet to set. The palette values must be calculated as
' 65536 * Red + 256 * Green + Blue

declare sub SetAllPalette (byval Palet AS DWORD)

declare sub SetColor (byval Colour as byte)

' SetFont needs a far pointer to a font array

declare sub SetFont (byval Font AS DWORD)

declare sub SetFont8x8 ()
declare sub SetFont8x16 ()
declare sub SetMouse (byval X as integer, byval Y as integer)
declare sub SetPalette (byval ColorNumber as word, byval Value as long)
declare sub SetPixel (byval X as word, byval Y as word, _
            byval Colour as byte)
declare sub SetViewPort (byval MinX as word, byval MinY as word, _
                         byval MaxX as word, byval MaxY as word)
declare sub ShowMouse ()

' Wait for start of vertical retrace

declare sub VertRet ()

