$compile exe
$cpu 80286
$error all off
$optimize speed

DEFINT A-Z
$INCLUDE "pbagi.bi"
$LINK "pbagi.pbu"
$LINK "pbagmous.obj"

' Font Choice
' 0 = 8x16
' 1 = 8x8
' 2 = 6x10 (in file 6x10.fnt)
' 3 = 12x20 (in file 12x20.fnt)

%WhichFont = 3

DECLARE SUB Pause (Seconds!)
DECLARE SUB ReadFont (File AS STRING, Font() AS BYTE)
DECLARE SUB Pixels ()
DECLARE SUB Lines ()
DECLARE SUB RectAngles ()
DECLARE SUB FRectAngles ()
DECLARE SUB Circles ()
DECLARE SUB Ellipses ()
DECLARE SUB FCircles ()
DECLARE SUB FEllipses ()
DECLARE SUB Text ()
DECLARE SUB Quit ()

DIM i AS INTEGER
DIM IsMouse AS SHARED INTEGER
DIM LenFont AS INTEGER
DIM FontPtr AS BYTE PTR

IF NOT InitGraph THEN
  PRINT "Initialization of 640x400x256 mode failed"
  END
END IF

SELECT CASE %WhichFont
CASE 0
  SetFont8x16
CASE 1
  SetFont8x8
CASE ELSE
  REDIM Font(0) AS BYTE
  SELECT CASE %WhichFont
  CASE 2
    FontFile$ = "6x10.fnt"
  CASE 3
    FontFile$ = "12x20.fnt"
  END SELECT
  ReadFont FontFile$, Font()
  FontPtr = VARPTR32(Font(0))
  SetFont FontPtr
END SELECT

IsMouse = InitMouse
IF NOT IsMouse THEN
  OutStr 0, 0, "Mouse initialization failed"
  OutStr 0, 20, "Press a key to continue"
  DO: LOOP UNTIL LEN(INKEY$)
  Dissolve
ELSE
  ShowMouse
  LimitMouse 0, 20, 639, 399
END IF

OutStr 0, 0, "When in demo screen"
OutStr 0, 20, "  press Enter or Left mouse button to continue"
OutStr 0, 40, "  press Escape or Right mouse button to exit"
OutStr 0, 60, "Press a key to continue with the first demo screen..."
DO: LOOP UNTIL LEN(INKEY$)
Dissolve

RANDOMIZE TIMER
DO WHILE LEN(INKEY$): LOOP

Pixels
Dissolve
Lines
Dissolve
RectAngles
Dissolve
FRectAngles
Dissolve
Circles
Dissolve
Ellipses
Dissolve
FCircles
Dissolve
FEllipses
Dissolve
Text
Dissolve

Quit

SUB Circles
  DIM GetKey AS STRING
  DIM MouseButton AS INTEGER
  SetColor 31
  SetViewPort 0, 0, 639, 399
  OutStr 176, 0, "AGI Graphics Circle Demo"
  SetViewPort 0, 20, 639, 399

  DO
    SetColor 256 * RND
    PutCircle 640 * RND, 400 * RND, 99 * RND + 1
    GetKey = INKEY$
    MouseButton = GetMouse(X, Y)
    ' Pause .1
  LOOP UNTIL LEN(GetKey) OR (MouseButton <> 0)

  IF GetKey = CHR$(27) OR (MouseButton AND 2) = 2 THEN Quit
  DO WHILE LEN(INKEY$): LOOP
END SUB

SUB Pause (Seconds!)
  Start! = TIMER
  StopIt! = Start! + Seconds!
  IF StopIt! > 86400! THEN
    StopIt! = StopIt! - 86400!
    DO
    LOOP UNTIL Start! > TIMER
  END IF
  DO
  LOOP WHILE TIMER < StopIt!
END SUB

SUB Ellipses
  DIM GetKey AS STRING
  DIM MouseButton AS INTEGER
  SetColor 31
  SetViewPort 0, 0, 639, 399
  OutStr 170, 0, "AGI Graphics Ellipse Demo"
  SetViewPort 0, 20, 639, 399

  DO
    SetColor 256 * RND
    Ellipse 640 * RND, 400 * RND, 99 * RND + 1, 99 * RND + 1
    GetKey = INKEY$
    MouseButton = GetMouse(X, Y)
    ' Pause .1
  LOOP UNTIL LEN(GetKey) OR (MouseButton <> 0)

  IF GetKey = CHR$(27) OR (MouseButton AND 2) = 2 THEN Quit
  DO WHILE LEN(INKEY$): LOOP
END SUB

SUB FCircles
  DIM GetKey AS STRING
  SetColor 31
  SetViewPort 0, 0, 639, 399
  OutStr 134, 0, "AGI Graphics Filled Circle Demo"
  SetViewPort 0, 20, 639, 399

  DO
    SetColor 256 * RND
    FillCircle 640 * RND, 400 * RND, 99 * RND + 1
    GetKey = INKEY$
    MouseButton = GetMouse(X, Y)
    ' Pause .1
  LOOP UNTIL LEN(GetKey) OR (MouseButton <> 0)

  IF GetKey = CHR$(27) OR (MouseButton AND 2) = 2 THEN Quit
  DO WHILE LEN(INKEY$): LOOP
END SUB

SUB FEllipses
  DIM GetKey AS STRING
  DIM MouseButton AS INTEGER
  SetColor 31
  SetViewPort 0, 0, 639, 399
  OutStr 128, 0, "AGI Graphics Filled Ellipse Demo"
  SetViewPort 0, 20, 639, 399

  DO
    SetColor 256 * RND
    FillEllipse 640 * RND, 400 * RND, 99 * RND + 1, 99 * RND + 1
    GetKey = INKEY$
    MouseButton = GetMouse(X, Y)
    ' Pause .1
  LOOP UNTIL LEN(GetKey) OR (MouseButton <> 0)

  IF GetKey = CHR$(27) OR (MouseButton AND 2) = 2 THEN Quit
  DO WHILE LEN(INKEY$): LOOP
END SUB

SUB FRectAngles
  DIM GetKey AS STRING
  DIM MouseButton AS INTEGER
  SetColor 31
  SetViewPort 0, 0, 639, 399
  OutStr 116, 0, "AGI Graphics Filled Rectangle Demo"
  SetViewPort 0, 20, 639, 399

  DO
    SetColor 256 * RND
    FillRectAngle 640 * RND, 400 * RND, 640 * RND, 400 * RND
    GetKey = INKEY$
    MouseButton = GetMouse(X, Y)
    ' Pause .1
  LOOP UNTIL LEN(GetKey) OR (MouseButton <> 0)

  IF GetKey = CHR$(27) OR (MouseButton AND 2) = 2 THEN Quit
  DO WHILE LEN(INKEY$): LOOP
END SUB

SUB Lines
  DIM GetKey AS STRING
  DIM MouseButton AS INTEGER
  SetColor 31
  SetViewPort 0, 0, 639, 399
  OutStr 188, 0, "AGI Graphics Line Demo"
  SetViewPort 0, 20, 639, 399

  DO
    SetColor 256 * RND
    PutLine 640 * RND, 400 * RND, 640 * RND, 400 * RND
    GetKey = INKEY$
    MouseButton = GetMouse(X, Y)
    ' Pause .1
  LOOP UNTIL LEN(GetKey) OR (MouseButton <> 0)

  IF GetKey = CHR$(27) OR (MouseButton AND 2) = 2 THEN Quit
  DO WHILE LEN(INKEY$): LOOP
END SUB

SUB Pixels
  DIM GetKey AS STRING
  DIM MouseButton AS INTEGER
  SetColor 31
  SetViewPort 0, 0, 639, 399
  OutStr 182, 0, "AGI Graphics Pixel Demo"
  SetViewPort 0, 20, 639, 399

  DO
    SetPixel 640 * RND, 380 * RND + 20, 256 * RND
    GetKey = INKEY$
    MouseButton = GetMouse(X, Y)
  LOOP UNTIL LEN(GetKey) OR (MouseButton <> 0)

  IF GetKey = CHR$(27) OR (MouseButton AND 2) = 2 THEN Quit
  DO WHILE LEN(INKEY$): LOOP
END SUB

SUB Quit
  IF IsMouse THEN
    EndMouse
  END IF
  CloseGraph
  END
END SUB

SUB ReadFont (File AS STRING, Font() AS BYTE)
  DIM i AS INTEGER
  DIM LenFont AS INTEGER
  DIM Handle AS INTEGER
  DIM Temp AS STRING

  Handle = FREEFILE
  OPEN File FOR BINARY AS #Handle
  LenFont = LOF(1)
  REDIM Font(LenFont - 1) AS BYTE
  Temp = STRING$(LenFont, 0)
  GET #Handle, , Temp
  CLOSE #Handle
  FOR i = 1 TO LenFont
    Font(i - 1) = ASC(MID$(Temp, i, 1))
  NEXT i
END SUB

SUB RectAngles
  DIM GetKey AS STRING
  DIM MouseButton AS INTEGER
  SetColor 31
  SetViewPort 0, 0, 639, 399
  OutStr 158, 0, "AGI Graphics Rectangle Demo"
  SetViewPort 0, 20, 639, 399

  DO
    SetColor 256 * RND
    RectAngle 640 * RND, 400 * RND, 640 * RND, 400 * RND
    GetKey = INKEY$
    MouseButton = GetMouse(X, Y)
    ' Pause .1
  LOOP UNTIL LEN(GetKey) OR (MouseButton <> 0)

  IF GetKey = CHR$(27) OR (MouseButton AND 2) = 2 THEN Quit
  DO WHILE LEN(INKEY$): LOOP
END SUB

SUB Text
  DIM GetKey AS STRING
  DIM MouseButton AS INTEGER
  SetColor 31
  SetViewPort 0, 0, 639, 399
  OutStr 188, 0, "AGI Graphics Text Demo"
  SetViewPort 0, 20, 639, 399

  DO
    SetColor 256 * RND
    OutStr 412 * RND, 360 * RND + 20, "This is sample text"
    GetKey = INKEY$
    MouseButton = GetMouse(X, Y)
    ' Pause .1
  LOOP UNTIL LEN(GetKey) OR (MouseButton <> 0)

  IF GetKey = CHR$(27) OR (MouseButton AND 2) = 2 THEN Quit
  DO WHILE LEN(INKEY$): LOOP
END SUB

